-- Weapon part ID for Biometric Analyser : wpn_fps_upg_o_health
-- Stuff managed mostly in NewRaycastWeaponBase.lua
-- Can easily be ported into StatTrak fixed mod, but i'm lazy
-- I also don't know what happen if you go past 999 on this scope :p

if not BiometricStatTrakSettings then
	log("[Biometric StatTrak] Error: Failed to create Mod Options menu")
	return
end

function NewRaycastWeaponBase:set_unit_health_display(unit)
	if not self._assembly_complete or not self._parts or not self._unit_health_displays then
		return
	end

	local value = false

	if BiometricStatTrakSettings and BiometricStatTrakSettings.options.show_session_kill then
		local wpn = managers.player:local_player():inventory():equipped_unit():base()._name_id
		if managers.statistics._global.session.killed_by_weapon[wpn] and managers.statistics._global.session.killed_by_weapon[wpn].count then
			value = managers.statistics._global.session.killed_by_weapon[wpn].count
			if managers.statistics._global.session.killed_by_weapon[wpn].grazecount then
				value = value + managers.statistics._global.session.killed_by_weapon[wpn].grazecount
			end
		else
			value = "0"
		end
	else
		if unit then
			if unit:in_slot(8) and alive(unit:parent()) then
				unit = unit:parent() or unit
			end

			local char_dmg_ext = unit:character_damage()
			value = char_dmg_ext and char_dmg_ext.health and char_dmg_ext:health() or false
		end

		value = value and math.round(value) * 10
	end

	local part, digital_gui_thd = nil
	for i, part_id in ipairs(self._unit_health_displays) do
		part = self._parts[part_id]

		if part then
			digital_gui_thd = part.unit:digital_gui_thd()

			if digital_gui_thd and digital_gui_thd.number_set then
				digital_gui_thd:number_set(value or false, false)
			end
		end
	end
end

-- A very wild and probably bad attempt at trying to fix Graze kill count in a session
-- At least i tried make it non-destructive for the stat data
-- Most of the logic was taken from Kill Feed from Hoppip ♥

Hooks:Add("BSTOnUnitDamaged", "BSTOnUnitDamagedGrazeKill", function (unit, damage_info)
	if not unit:character_damage():dead() or not damage_info or not damage_info.attacker_unit then
		return
	end

	if not damage_info.attacker_unit:base().is_local_player then
		return
	end

	local variant = damage_info.variant
	local weapon_unit = damage_info.weapon_unit
	if not alive(weapon_unit) and damage_info.attacker_unit:inventory() then
		if variant == "graze" then
			weapon_unit = damage_info.attacker_unit:inventory():equipped_unit()
			local weapon_name = weapon_unit:base()._name_id or weapon_unit:name()
			if managers.statistics._global.session.killed_by_weapon[weapon_name] and managers.statistics._global.session.killed_by_weapon[weapon_name].grazecount then
				managers.statistics._global.session.killed_by_weapon[weapon_name].grazecount = managers.statistics._global.session.killed_by_weapon[weapon_name].grazecount + 1
			else
				managers.statistics._global.session.killed_by_weapon[weapon_name].grazecount = 1
			end
		end
	end
end)