-- Took most of the snippets from the CrimeNET_Cleaner option menu, no idea if there's a template somewhere i'm potato
--[[
	We setup the global table for our mod, along with some path variables, and an options table.
	We cache the ModPath directory, so that when our hooks are called, we aren't using the ModPath from a
		different mod.
]]

_G.BiometricStatTrakSettings = _G.BiometricStatTrakSettings or {}
BiometricStatTrakSettings.ModPath = ModPath
BiometricStatTrakSettings.SaveFilePath = SavePath .. "BiometricStatTrak.json"
BiometricStatTrakSettings.OptionsPath = ModPath .. "options.json"
BiometricStatTrakSettings.options = {}

function BiometricStatTrakSettings:Save()
	local file = io.open( self.SaveFilePath, "w+" )
	if file then
		file:write( json.encode( self.options ) )
		file:close()
	end
end


function BiometricStatTrakSettings:Load()
	local file = io.open( self.SaveFilePath, "r" )
	if file then
    self.options = json.decode( file:read("*all") )
		file:close()
	end
end


function BiometricStatTrakSettings:LoadDefaults()
	-- sets default vals in .data with default_value from menujson  
	local file = io.open(self.OptionsPath, "r")
	if file then
		local file_content = file:read("*all")
		file:close()
        local content = json.decode(file_content)
		local items = content.items

        for _ , item in pairs(items) do
            self.options[item.value] = item.default_value
        end
    end
end
BiometricStatTrakSettings:LoadDefaults()
log("[Biometric StatTrak] : BST Initialized")

-- Taken from Lobby Player Info mod by TdlQ
Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_BiometricStatTrakSettings", function(loc)
    for __, filename in pairs(file.GetFiles(BiometricStatTrakSettings.ModPath .. "loc/")) do
            local str = filename:match('^(.*).txt$')
            if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
                    loc:load_localization_file(BiometricStatTrakSettings.ModPath .. "loc/" .. filename)
                    break
            end
    end
    loc:load_localization_file(BiometricStatTrakSettings.ModPath .. "loc/english.txt", false)
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_BiometricStatTrakSettings", function( menu_manager )

    MenuCallbackHandler.bst_callback_toggle = function(this, item)
        BiometricStatTrakSettings.options[item:name()] = item:value() == 'on'
        log(json.encode( BiometricStatTrakSettings.options ))
    end

    MenuCallbackHandler.bst_callback_save = function(self, item)
		BiometricStatTrakSettings:Save()
        log("[Biometric StatTrak] : settings saved")
	end

	BiometricStatTrakSettings:Load()
	MenuHelper:LoadFromJsonFile( BiometricStatTrakSettings.OptionsPath, BiometricStatTrakSettings, BiometricStatTrakSettings.options )    

end )